/// <reference types="node" />
import { TapeSession } from './tape';
export declare const CacheModeEnum: {
    OFF: number;
    STANDARD: number;
    AGGRESSIVE: number;
};
interface GrooveConfiguration {
    commandTimeout?: number;
    port?: number;
    controlPort?: number;
    proxyServer?: string;
    proxyUsername?: string;
    proxyPassword?: string;
    authUsername?: string;
    authPassword?: string;
}
declare class Groove {
    process: any;
    executablePath: string | null;
    commandTimeout: number;
    port: number;
    controlPort: number;
    proxyServer: string | null;
    proxyUsername: string | null;
    proxyPassword: string | null;
    authUsername: string | null;
    authPassword: string | null;
    baseUrlProxy: string;
    baseUrlControl: string;
    certificate: Buffer;
    silenceLogs: boolean;
    constructor(config: GrooveConfiguration);
    launch(): Promise<void>;
    stop(): Promise<void>;
    tapeStart(): Promise<void>;
    tapeGet(): Promise<TapeSession>;
    tapeLoad(session: TapeSession): Promise<void>;
    tapeStop(): Promise<void>;
    setCacheMode(mode: number): Promise<void>;
    getExecutablePath(): Promise<string>;
}
export default Groove;
